<html>
<head>
  <meta content="text/html;charset=utf-8" http-equiv="Content-Type">
  <meta content="utf-8" http-equiv="encoding">
  <title>Deepracer Log Analysus - setup </title>
  <style type="text/css">
    body, html {
      font-family: sans-serif;
    }
  </style>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.5.0/css/all.css" integrity="sha384-B4dIYHKNBt8Bc12p+WXckhzcICo0wtJAoU8YZTY5qE0Id1GSseTk6S+L3BlXeVIU" crossorigin="anonymous">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/vis/4.21.0/vis.min.css">
  <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/vis/4.21.0/vis.js"></script>
  <script type="text/javascript" src="https://unpkg.com/alasql@4.1.2/dist/alasql.min.js"></script>

  <script type="text/javascript" src="./javascript/createObjects.js"></script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/xlsx/0.18.5/shim.min.js" integrity="sha512-nPnkC29R0sikt0ieZaAkk28Ib7Y1Dz7IqePgELH30NnSi1DzG4x+envJAOHz8ZSAveLXAHTR3ai2E9DZUsT8pQ==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

  <script type="text/javascript">
    function loadFile(event) {
      console.log("loadFile" )
      alasql('SELECT * FROM FILE(?,{headers:true,separator:","})', [event],function(data){
          console.log("load",data )
            
      });
    };
    function loadCSV(event) {
      console.log("load CSV",event )
      alasql('SELECT * FROM CSV(?,{headers:false,separator:","})', [event],function(data){
          console.log("load",data )
            
      });
    };

    function getTestData(steps = 50, axisMax = 314, axisStep = axisMax / steps, custom=(x,y)=>Math.sin(x/50) * Math.cos(y/50) * 50 + 50) {
      const data=new vis.DataSet();
      let counter = 0;
      for (let x = 0; x < axisMax; x+=axisStep) {
        for (let y = 0; y < axisMax; y+=axisStep) {
          var value = custom(x,y);
          data.add({id:counter++,x:x,y:y,z:value,style:value});
        }
      }
      return data
    }

    function addTextarea(table,targetElemenName){
      alasql('SELECT * INTO HTML("#"+targetElemenName,{headers:true}) FROM '+table)
    } 
    function runSqlScript(id){
      console.log(" runSql ",id)
      const result=alasql('SOURCE "#'+id+'"')
      console.log(" runSql completed ",id, result)
      return result
    } 

    function addTextArea(target,data) {
       const x = document.createElement("TEXTAREA");
       const t = document.createTextNode(data);
       x.appendChild(t);
       document.getElementById(target).appendChild(x);
    }

    function loadXLSX(target,url="https://gitlab.com/loanstar1/deepracer/-/blob/main/Model_performance_v1.xlsx"){
      alasql('SELECT * FROM xlsx(url,{headers:true})', [], 
        (data)=>{
         addTextArea(target,data)
      });
    }
    function loadObjectURL(file){
      const fileAsObjectUrl = URL.createObjectURL( file );
      alasql.promise('select * from xlsx(?, {autoExt: false})', [fileAsObjectUrl])
        .then(()=>{ console.log( arguments ) }, ()=>{ console.log( arguments ) } );
    }
/*
let reader = new FileReader();
let csvContents = "";
reader.addEventListener('loadend', (e) => {
 csvContents+= e.srcElement.result;
});
alasql.promise('select * from CSV(?)', csvContents);
*/
   </script>
</head>
<body>
<h1>Deepracer Log Analysis</h1>
  <h2>Create Objects</h2>
  <input type="button" value="Create Objects" onclick="createObjects()"/>
  <input type="button" value="Delete Objects" onclick="deleteObjects()"/>
  <input type="button" value="Delete Objects" onclick="deleteObjects()"/>
  <h2>Load Data .txt</h2>
<input id="readfile" type="file" onchange="loadFile(event)"/>
  <h2>Load Data .csv</h2>
<input id="readCSV" type="file" onchange="loadCSV(event)"/>
 </script>
 <h2>Create Tables</h2>
  <input id="3d" type="button" value="create" onclick="console.log('3d onclink');runSqlScript('sqlSetup');"/>
  <div id="info"></div>
 <h2>load models</h2>
  <textarea id="models" name="data retrieved" rows="5" cols="33"></textarea>
  <input id="loadmodels" type="button" value="load" onclick=" console.log('loadmodels onclick'); loadXLSX('#models')"/>
 <h2>load cities from url</h2>
  <textarea id="citiesTextArea" name="data retrieved" rows="5" cols="33"></textarea>
  <input id="loadcities" type="button" value="load" onclick=" console.log('loadcities onclick'); loadFile('#citiesTextArea')"/>
  


  <h2>load form</h2>
 
  <form name="uploadForm">
    <div>
      <input id="uploadInput" type="file" multiple />
      <label for="fileNum">Selected files:</label>
      <output id="fileNum">0</output>;
      <label for="fileSize">Total size:</label>
      <output id="fileSize">0</output>
    </div>
    <div><input type="submit" value="Send file" /></div>
  </form>

  <script>
    const uploadInput = document.getElementById("uploadInput");
    uploadInput.addEventListener(
      "change",
      () => {
        // Calculate total size
        let numberOfBytes = 0;
        for (const file of uploadInput.files) {
          numberOfBytes += file.size;
        }

        // Approximate to the closest prefixed unit
        const units = [
          "B",
          "KiB",
          "MiB",
          "GiB",
          "TiB",
          "PiB",
          "EiB",
          "ZiB",
          "YiB",
        ];
        const exponent = Math.min(
          Math.floor(Math.log(numberOfBytes) / Math.log(1024)),
          units.length - 1,
        );
        const approx = numberOfBytes / 1024 ** exponent;
        const output =
          exponent === 0
            ? `${numberOfBytes} bytes`
            : `${approx.toFixed(3)} ${
                units[exponent]
              } (${numberOfBytes} bytes)`;

        document.getElementById("fileNum").textContent =
          uploadInput.files.length;
        document.getElementById("fileSize").textContent = output;
      },
      false,
    );
  </script>


<h2>load form aaa</h2>
<input
  type="file"
  id="fileElem"
  multiple
  accept="image/*"
  style="display:none" />
<a href="#" id="fileSelect">Select some files</a>
<div id="fileList">
  <p>No files selected!</p>
</div>

<script>
const fileSelect = document.getElementById("fileSelect"),
  fileElem = document.getElementById("fileElem"),
  fileList = document.getElementById("fileList");

fileSelect.addEventListener(
  "click",
  (e) => {
    if (fileElem) {
      fileElem.click();
    }
    e.preventDefault(); // prevent navigation to "#"
  },
  false,
);

fileElem.addEventListener("change", handleFiles, false);

function handleFiles() {
  if (!this.files.length) {
    fileList.innerHTML = "<p>No files selected!</p>";
  } else {
    fileList.innerHTML = "";
    const list = document.createElement("ul");
    fileList.appendChild(list);
    for (let i = 0; i < this.files.length; i++) {
      const li = document.createElement("li");
      list.appendChild(li);

      const img = document.createElement("img");
      img.src = URL.createObjectURL(this.files[i]);
      img.height = 60;
      img.onload = () => {
        URL.revokeObjectURL(img.src);
      };
      li.appendChild(img);
      const info = document.createElement("span");
      info.innerHTML = `${this.files[i].name}: ${this.files[i].size} bytes`;
      li.appendChild(info);
    }
  }
}

</script>

  </body>
</html>